/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

 /*
 * MarcacionHuella.java
 *
 * Created on 29/10/2014, 11:57:00 AM
 */
package Formularios;

import javax.swing.JOptionPane;
import javax.swing.UIManager;
import BD.ConexionBD;
import conexion.CADO;
import java.awt.BorderLayout;
import java.awt.Color;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Radio Universitaria
 */
public class MarcacionHuella1 extends javax.swing.JFrame {

    int idclienteestado = 0;
    int contratoid = 0;
    Date ahora = new Date();
    String fechaactual = "";
    int valor = -1;
    int idsedelogin = 0;

    /**
     * Creates new form MarcacionHuella
     */
    public MarcacionHuella1(int val, int idsede) {
        valor = val;
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Imposible modificar el tema visual", "Lookandfeel inválido.",
                    JOptionPane.ERROR_MESSAGE);
        }

        initComponents();
        idsedelogin = idsede;
        identificarHuella();
        txtArea.setEditable(false);

        PanelLogo F = new PanelLogo();
        this.add(F, BorderLayout.CENTER);
        this.pack();
    }
    CADO cd = new CADO();

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")

    ConexionBD con = new ConexionBD();

    public void identificarHuella() {
        try {
            //Establece los valores para la sentencia SQL
            Connection c = con.conectar();

            //Obtiene todas las huellas de la bd
            String sql = "SELECT cliente.id,CONCAT(persona.apellidos,' ',persona.nombres) as ApellidosNombres, persona.dni, "
                    + "cliente.nacimiento, cliente.idsede  FROM persona join cliente on cliente.persona_id=persona.id "
                    + "where cliente.estado='N' and cliente.id=" + valor;

            ResultSet rs = cd.consultaconresp(sql);

            //Si se encuentra el nombre en la base de datos
            while (rs.next()) {

                int somhue_id = valor;
                idclienteestado = somhue_id;
                int idsedecliente = rs.getInt("cliente.idsede");
                String nombres = rs.getObject("ApellidosNombres").toString();
                String nacimiento = rs.getString("cliente.nacimiento");
                //String dni = rs.getObject("dni").toString();
                // Blob blob =(Blob) rs.getBlob("foto");

                SimpleDateFormat formateador = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                SimpleDateFormat formateador2 = new SimpleDateFormat("yyyy-MM-dd");
                SimpleDateFormat formateador3 = new SimpleDateFormat("HH:mm:ss");
                SimpleDateFormat formateador4 = new SimpleDateFormat("MM-dd");

                String cumpleano = formateador4.format(ahora);
                String naci = nacimiento.substring(5, 7) + "-" + nacimiento.substring(8, 10);

                String actual = formateador.format(ahora);
                String fecha = formateador2.format(ahora);
                String hora = formateador3.format(ahora);
                String estado = "";
                fechaactual = fecha;
                this.lblPersona.setText(nombres.toUpperCase());
                this.lblHora1.setText("HORA: ");
                this.lblHora.setText(hora);
                //ImageIcon image = new ImageIcon(blob.getBytes(1,(int)blob.length()));
                //  this.lblFoto.setIcon(image);

                PreparedStatement mar = c.prepareStatement("SELECT id,fecha,horaentrada,horasalida,cliente_id, idsede "
                        + "FROM marcacion where cliente_id = " + somhue_id + " and fecha = '" + fecha + "' and horasalida is null order by id desc LIMIT 1");
                ResultSet rs2 = mar.executeQuery();
                int marcacion_id = 0;
                String horasalida = "";
                while (rs2.next()) {
                    marcacion_id = rs2.getInt("id");
                    horasalida = rs2.getString("horasalida");
                }

                int cont = 0;
                int idcontrato = 0, duracion = 0, sumarmes = 0, vigencia = 0, incremento = 0, totalasistencias = 0, diasemana = 0, idsedecontrato = 0;
                String fechainicio = "", fechatermino = "";
                //Border border = BorderFactory.createLineBorder(Color.GREEN, 5);
                PreparedStatement marcontrato = c.prepareStatement("select contrato.id, inicio, termino, idsede, "
                        + "(date_format(termino,'%m')-date_format(inicio,'%m')) as duracion, CONCAT(ELT(WEEKDAY(CURRENT_DATE) + 1, '1', '2', '3', '4', '5', '6', '7')) AS dia_semana, "
                        + "period_diff(date_format(CURRENT_DATE,'%Y%m'),date_format(inicio,'%Y%m')) as sumarmes, "
                        + "DATEDIFF(CURRENT_DATE,DATE_ADD(inicio, INTERVAL period_diff(date_format(CURRENT_DATE,'%Y%m'),date_format(inicio,'%Y%m')) month)) as vigencia "
                        + "from contrato where cliente_id=" + somhue_id + " and IF(terminoxcongelamiento IS NULL, termino, terminoxcongelamiento) > CURDATE() order by contrato.id DESC limit 1");
                ResultSet rs3 = marcontrato.executeQuery();
                while (rs3.next()) {
                    idcontrato = rs3.getInt("contrato.id");
                    duracion = rs3.getInt("duracion");
                    fechainicio = rs3.getString("inicio");
                    fechatermino = rs3.getString("termino");
                    sumarmes = rs3.getInt("sumarmes");
                    vigencia = rs3.getInt("vigencia");
                    diasemana = rs3.getInt("dia_semana");
                    idsedecontrato = rs3.getInt("idsede");
                }

                //int idcontrato=Contratovigente(somhue_id);
                if (idcontrato > 0) {
                    if (idsedelogin != idsedecontrato) {
                        if (idsedelogin == 2) {
                            if (sumarmes == 0) {
                                incremento = 1;
                            } else {
                                if (vigencia >= 0) {
                                    incremento = sumarmes + 1;
                                } else {
                                    incremento = sumarmes;
                                    sumarmes--;
                                    //incremento=sumarmes+1;
                                }
                            }
                            if (duracion >= 3 && duracion < 6) {
                                PreparedStatement marasistencia = c.prepareStatement("select count(id) as total from marcacion "
                                        + "where cliente_id=" + somhue_id + " "
                                        + "and idsede=" + idsedelogin + " "
                                        + "and fecha>=DATE_ADD('" + fechainicio + "', INTERVAL '" + sumarmes + "' MONTH) "
                                        + "and fecha<DATE_ADD('" + fechainicio + "', INTERVAL '" + incremento + "' MONTH) "
                                        + "and horasalida is not null");
                                ResultSet rs4 = marasistencia.executeQuery();
                                while (rs4.next()) {
                                    totalasistencias = rs4.getInt("total");
                                }
                                if (totalasistencias >= 4) {
                                    Border border2 = BorderFactory.createLineBorder(Color.RED, 5);
                                    this.lblFoto.setBorder(border2);
                                    JOptionPane.showMessageDialog(null, "Ud. ya asistió 4 veces en este mes.", "", JOptionPane.ERROR_MESSAGE);
                                } else {
                                    if (marcacion_id > 0) {
                                        if (cont == 0) {
                                            //int marcacion_id = rs2.getInt("id");
                                            //int idsedecliente=rs2.getInt("idsede");

                                            if (horasalida != null) {
                                                estado = "BIENVENIDO";
                                                PreparedStatement guardarStmt = c.prepareStatement("INSERT INTO marcacion(fecha, horaentrada,horasalida,cliente_id, idsede) values('" + fecha + "','" + actual + "',null," + somhue_id + "," + idsedelogin + ")");
                                                guardarStmt.execute();
                                                guardarStmt.close();
                                                //this.lblFoto.setBorder(border);
                                            } else {
                                                estado = "HASTA PRONTO";
                                                PreparedStatement guardarStmt = c.prepareStatement("UPDATE marcacion SET horasalida = '" + actual + "' WHERE id = " + marcacion_id);
                                                guardarStmt.execute();
                                                guardarStmt.close();
                                            }

                                            cont++;
                                        }
                                    } else {
                                        estado = "BIENVENIDO";
                                        PreparedStatement guardarStmt = c.prepareStatement("INSERT INTO marcacion(fecha, horaentrada,horasalida,cliente_id, idsede) values('" + fecha + "','" + actual + "',null," + somhue_id + "," + idsedelogin + ")");
                                        guardarStmt.execute();
                                        guardarStmt.close();
                                    }

                                    //System.out.println(cont+"//"+actual);
                                    this.lblSituacion.setText(estado);
                                    SituacionCliente(somhue_id);
                                    //Asistencias(somhue_id);
                                    listarContratoVigente(idcontrato);
                                    listarEstados(idcontrato);

                                    if (cumpleano.equals(naci)) {
                                        Onomastico on = new Onomastico(nombres.toUpperCase());
                                        on.setVisible(true);
                                    }

                                    Border border = BorderFactory.createLineBorder(Color.GREEN, 5);
                                    this.lblFoto.setBorder(border);
                                }
                            } else {
                                Border border2 = BorderFactory.createLineBorder(Color.RED, 5);
                                this.lblFoto.setBorder(border2);
                                JOptionPane.showMessageDialog(null, "Ud. No Tiene Ingreso permitido. Contrato menor a 3 meses", "", JOptionPane.ERROR_MESSAGE);
                            }

                        } else {
                            PreparedStatement marasistencia2 = c.prepareStatement("select count(id) as total from marcacion "
                                    + "where cliente_id=" + somhue_id + " "
                                    + "and idsede=" + idsedelogin + " "
                                    + "and fecha>=DATE_ADD(CURRENT_DATE, INTERVAL -'" + (diasemana - 1) + "' DAY) "
                                    + "and fecha<DATE_ADD(CURRENT_DATE, INTERVAL '" + (7 - diasemana) + "' DAY) "
                                    + "and horasalida is not null");
                            ResultSet rs5 = marasistencia2.executeQuery();
                            while (rs5.next()) {
                                totalasistencias = rs5.getInt("total");
                            }
                            if (totalasistencias >= 2) {
                                Border border2 = BorderFactory.createLineBorder(Color.RED, 5);
                                this.lblFoto.setBorder(border2);
                                JOptionPane.showMessageDialog(null, "Ud. ya asistió 2 veces en esta semana.", "", JOptionPane.ERROR_MESSAGE);
                            } else {
                                if (marcacion_id > 0) {
                                    if (cont == 0) {
                                        //int marcacion_id = rs2.getInt("id");
                                        //int idsedecliente=rs2.getInt("idsede");

                                        if (horasalida != null) {
                                            estado = "BIENVENIDO";
                                            PreparedStatement guardarStmt = c.prepareStatement("INSERT INTO marcacion(fecha, horaentrada,horasalida,cliente_id, idsede) values('" + fecha + "','" + actual + "',null," + somhue_id + "," + idsedelogin + ")");
                                            guardarStmt.execute();
                                            guardarStmt.close();
                                            //this.lblFoto.setBorder(border);
                                        } else {
                                            estado = "HASTA PRONTO";
                                            PreparedStatement guardarStmt = c.prepareStatement("UPDATE marcacion SET horasalida = '" + actual + "' WHERE id = " + marcacion_id);
                                            guardarStmt.execute();
                                            guardarStmt.close();
                                        }

                                        cont++;
                                    }
                                } else {
                                    estado = "BIENVENIDO";
                                    PreparedStatement guardarStmt = c.prepareStatement("INSERT INTO marcacion(fecha, horaentrada,horasalida,cliente_id, idsede) values('" + fecha + "','" + actual + "',null," + somhue_id + "," + idsedelogin + ")");
                                    guardarStmt.execute();
                                    guardarStmt.close();
                                }

                                //System.out.println(cont+"//"+actual);
                                this.lblSituacion.setText(estado);
                                SituacionCliente(somhue_id);
                                //Asistencias(somhue_id);
                                listarContratoVigente(idcontrato);
                                listarEstados(idcontrato);

                                if (cumpleano.equals(naci)) {
                                    Onomastico on = new Onomastico(nombres.toUpperCase());
                                    on.setVisible(true);
                                }

                                Border border = BorderFactory.createLineBorder(Color.GREEN, 5);
                                this.lblFoto.setBorder(border);
                            }
                        }

                    } else {
                        if (marcacion_id > 0) {
                            if (cont == 0) {
                                //int marcacion_id = rs2.getInt("id");
                                //int idsedecliente=rs2.getInt("idsede");

                                if (horasalida != null) {
                                    estado = "BIENVENIDO";
                                    PreparedStatement guardarStmt = c.prepareStatement("INSERT INTO marcacion(fecha, horaentrada,horasalida,cliente_id, idsede) values('" + fecha + "','" + actual + "',null," + somhue_id + "," + idsedelogin + ")");
                                    guardarStmt.execute();
                                    guardarStmt.close();
                                    //this.lblFoto.setBorder(border);
                                } else {
                                    estado = "HASTA PRONTO";
                                    PreparedStatement guardarStmt = c.prepareStatement("UPDATE marcacion SET horasalida = '" + actual + "' WHERE id = " + marcacion_id);
                                    guardarStmt.execute();
                                    guardarStmt.close();
                                }

                                cont++;
                            }
                        } else {
                            estado = "BIENVENIDO";
                            PreparedStatement guardarStmt = c.prepareStatement("INSERT INTO marcacion(fecha, horaentrada,horasalida,cliente_id, idsede) values('" + fecha + "','" + actual + "',null," + somhue_id + "," + idsedelogin + ")");
                            guardarStmt.execute();
                            guardarStmt.close();
                        }

                        //System.out.println(cont+"//"+actual);
                        this.lblSituacion.setText(estado);
                        SituacionCliente(somhue_id);
                        //Asistencias(somhue_id);
                        listarContratoVigente(idcontrato);
                        listarEstados(idcontrato);

                        if (cumpleano.equals(naci)) {
                            Onomastico on = new Onomastico(nombres.toUpperCase());
                            on.setVisible(true);
                        }

                        Border border = BorderFactory.createLineBorder(Color.GREEN, 5);
                        this.lblFoto.setBorder(border);
                    }
                    //if(idsedelogin==)

                } else {
                    Border border2 = BorderFactory.createLineBorder(Color.RED, 5);
                    this.lblFoto.setBorder(border2);
                    JOptionPane.showMessageDialog(null, "Ud. no tiene CONTRATO VIGENTE", "", JOptionPane.ERROR_MESSAGE);
                }
                return;
            }
            //Si no encuentra alguna huella correspondiente al nombre lo indica con un mensaje

            JOptionPane.showMessageDialog(null, "No existe ningún registro que coincida con la huella", "Verificacion de Huella", JOptionPane.ERROR_MESSAGE);
            //setTemplate(null);
        } catch (SQLException e) {
            //Si ocurre un error lo indica en la consola
            System.err.println("Error al identificar huella dactilar." + e.getMessage());
        } finally {
            con.desconectar();
        }
    }

    public int Contratovigente(int id) {
        int Idper = 0;
        String sql = "";
        try {
            sql = "select contrato.id from contrato where cliente_id ='" + id + "' and termino > CURDATE() order by contrato.id DESC limit 1";

            ResultSet rs = cd.consultaconresp(sql);
            while (rs.next()) {
                Idper = rs.getInt("contrato.id");
            }
            return Idper;
        } catch (Exception ex) {
            return 0;
        }
    }

    public void SituacionCliente(int id) {
        String estad = "";
        String sql = "";
        try {
            sql = "select situacion from cliente where id ='" + id + "'";

            ResultSet rs = cd.consultaconresp(sql);
            while (rs.next()) {
                estad = rs.getString("situacion");
            }

            if (estad.equals("A")) {
                this.lblEstadoCliente.setText("Situación: Activo");
            } else {
                if (estad.equals("I")) {
                    this.lblEstadoCliente.setText("Situación: Invitado");
                } else {
                    this.lblEstadoCliente.setText("Situación: Retirado");
                }
            }

        } catch (Exception e) {
            System.out.println("error: " + e.getMessage());
        }
    }

    public void listarContratoVigente(int idcontrato) {
        //int idcontrato=0;
        //idcontrato=Contratovigente(id);   
        //contratoid=idcontrato;
        String fechainicio = "", fechafin = "";

        String sql = "SELECT contrato.id,servicio.nombre,persona.nombres,cliente_id,inscripcion,inicio,termino,montototal,"
                + "contrato.estado,contrato.tipo,observacion FROM contrato "
                + "JOIN servicio on contrato.servicio_id=servicio.id "
                + "join vendedor on contrato.vendedor_id=vendedor.id "
                + "join persona on vendedor.persona_id=persona.id "
                + "where (contrato.estado='N' or contrato.estado = 'T') and contrato.id='" + idcontrato + "'";

        ResultSet rs = cd.consultaconresp(sql);
        DefaultTableModel dt = new DefaultTableModel();
        dt.addColumn("Servicio");
        //dt.addColumn("Vendedor");
        dt.addColumn("Inicio");
        dt.addColumn("Termino");
        //dt.addColumn("Monto");
        dt.addColumn("Vence");

        try {

            while (rs.next()) {
                Vector vFila = new Vector();

                vFila.addElement(rs.getString(2));
                //vFila.addElement(rs.getString(3));
                if (rs.getString(6).length() > 0) {
                    fechainicio = rs.getString(6).substring(8, 10) + "/" + rs.getString(6).substring(5, 7) + "/" + rs.getString(6).substring(0, 4);
                }
                vFila.addElement(fechainicio);
                if (rs.getString(7).length() > 0) {
                    fechafin = rs.getString(7).substring(8, 10) + "/" + rs.getString(7).substring(5, 7) + "/" + rs.getString(7).substring(0, 4);
                }
                vFila.addElement(fechafin);
                //vFila.addElement(rs.getString(8));
                String inicio = "", fin = "";
                inicio = fechaactual.substring(0, 4) + "/" + fechaactual.substring(5, 7) + "/" + fechaactual.substring(8, 10);
                fin = rs.getString(7).substring(0, 4) + "/" + rs.getString(7).substring(5, 7) + "/" + rs.getString(7).substring(8, 10);
                vFila.addElement("En " + calculateDays(inicio, fin) + " días");

                dt.addRow(vFila);
            }

            this.tblContrato.setModel(dt);

        } catch (Exception e) {
            System.out.println("error: " + e.getMessage());
        }

    }

    public static long calculateDays(String startDate, String endDate) {
        Date sDate = new Date(startDate);
        Date eDate = new Date(endDate);
        Calendar cal3 = Calendar.getInstance();
        cal3.setTime(sDate);
        Calendar cal4 = Calendar.getInstance();
        cal4.setTime(eDate);
        return daysBetween(cal3, cal4);
    }

    /**
     * Using Calendar - THE CORRECT WAY*
     */
    public static long daysBetween(Calendar startDate, Calendar endDate) {
        Calendar date = (Calendar) startDate.clone();
        long daysBetween = 0;
        while (date.before(endDate)) {
            date.add(Calendar.DAY_OF_MONTH, 1);
            daysBetween++;
        }
        return daysBetween;
    }

    public void listarEstados(int idcontrato) {
        //int idcontrato=0;
        //idcontrato=Contratovigente(id);  
        String sql = "";
        sql = "SELECT c.monto, c.fechavencimiento, c.estado, (SELECT sum(monto) as total FROM pago where compromisopago_id=c.id) as montopagado from compromisopago c where c.contrato_id=" + idcontrato;
        //sql="SELECT s.nombre,c.inicio,c.termino,c.montototal,cp.estado FROM contrato c join servicio s on c.servicio_id=s.id join compromisopago cp on c.id=cp.contrato_id where c.cliente_id="+id;
        // sql= "SELECT cliente.id,CONCAT(persona.apellidos,' ',persona.nombres) as ApellidosNombres, persona.dni, cliente.huella  FROM persona join cliente on cliente.persona_id=persona.id where cliente.estado='N' and CONCAT(persona.apellidos,' ',persona.nombres) order by persona.apellidos asc";
        int contador = 1;
        String fechainicio = "", fechafin = "";
        ResultSet rs = cd.consultaconresp(sql);
        DefaultTableModel dt = new DefaultTableModel();
        dt.addColumn("N° Couta");
        dt.addColumn("Monto");
        dt.addColumn("Vencimiento");
        dt.addColumn("Monto Pagado");
        dt.addColumn("Monto Adeudado");
        dt.addColumn("Estado");

        try {
            while (rs.next()) {
                Vector vFila = new Vector();
                vFila.addElement(contador);
                vFila.addElement(rs.getString(1));
                if (rs.getString(2).length() > 0) {
                    fechafin = rs.getString(2).substring(8, 10) + "/" + rs.getString(2).substring(5, 7) + "/" + rs.getString(2).substring(0, 4);
                }
                vFila.addElement(fechafin);
                if (rs.getString(4) != null) {
                    vFila.addElement(rs.getString(4));
                } else {
                    vFila.addElement("00.00");
                }

                if (rs.getString(4) != null) {
                    vFila.addElement(Double.parseDouble(rs.getString(1)) - Double.parseDouble(rs.getString(4)));
                } else {
                    vFila.addElement(Double.parseDouble(rs.getString(1)));
                }

                if (rs.getString(3).equals("P")) {
                    vFila.addElement("Pendiente");
                } else {
                    vFila.addElement("Cancelado");
                }
                dt.addRow(vFila);
                contador++;
            }
//
            if (contador == 0) {
                Vector vFila = new Vector();
                vFila.addElement("No tiene compromisos de pagos");
            }
            this.tblEstado.setModel(dt);
        } catch (Exception e) {
            System.out.println("error: " + e.getMessage());
        }

    }

    public void Asistencias(int id) {
        String sql = "";
        sql = "SELECT fecha,horaentrada,horasalida FROM marcacion WHERE  cliente_id='" + id + "' order by fecha desc limit 5";
        int cont = 0;

        ResultSet rs = cd.consultaconresp(sql);
        DefaultTableModel dt = new DefaultTableModel();
        dt.addColumn("Num");
        dt.addColumn("Fecha");
        dt.addColumn("Entrada");
        dt.addColumn("Salida");

        try {

            while (rs.next()) {
                Vector vFila = new Vector();
                vFila.addElement(cont + 1);
                vFila.addElement(rs.getString(1));
                vFila.addElement(rs.getString(2));
                vFila.addElement(rs.getString(3));

                dt.addRow(vFila);
            }

            // this.tblAsistencia.setModel(dt);
        } catch (Exception e) {
            System.out.println("error: " + e.getMessage());
        }

    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        btnSalir = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtArea = new javax.swing.JTextArea();
        lblFoto = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        lblSituacion = new javax.swing.JLabel();
        lblEstadoCliente = new javax.swing.JLabel();
        lblPersona = new javax.swing.JLabel();
        lblHora1 = new javax.swing.JLabel();
        lblHora = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        tblContrato = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        tblEstado = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Marcacion");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Acciones", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION));

        btnSalir.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnSalir.setText("Salir");
        btnSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalirActionPerformed(evt);
            }
        });

        txtArea.setColumns(20);
        txtArea.setFont(new java.awt.Font("Lucida Sans", 1, 10)); // NOI18N
        txtArea.setRows(5);
        jScrollPane1.setViewportView(txtArea);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 516, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(197, 197, 197)
                        .addComponent(btnSalir, javax.swing.GroupLayout.PREFERRED_SIZE, 133, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnSalir, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        lblFoto.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblFoto.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/huella.jpg"))); // NOI18N

        jLabel1.setFont(new java.awt.Font("Tahoma", 3, 24)); // NOI18N
        jLabel1.setText("SISTEMA DE MARCACIÓN");

        lblSituacion.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        lblSituacion.setForeground(new java.awt.Color(255, 0, 51));

        lblEstadoCliente.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        lblEstadoCliente.setForeground(new java.awt.Color(255, 0, 51));

        lblPersona.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N

        lblHora1.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N

        lblHora.setFont(new java.awt.Font("Tahoma", 1, 22)); // NOI18N

        tblContrato.setFont(new java.awt.Font("Tahoma", 1, 16)); // NOI18N
        tblContrato.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tblContrato.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                tblContratoKeyTyped(evt);
            }
        });
        jScrollPane2.setViewportView(tblContrato);

        tblEstado.setFont(new java.awt.Font("Tahoma", 1, 16)); // NOI18N
        tblEstado.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tblEstado.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                tblEstadoKeyTyped(evt);
            }
        });
        jScrollPane3.setViewportView(tblEstado);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 132, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(109, 109, 109))
            .addGroup(layout.createSequentialGroup()
                .addGap(55, 55, 55)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lblFoto, javax.swing.GroupLayout.PREFERRED_SIZE, 148, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(27, 27, 27)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 330, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(lblSituacion, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(lblEstadoCliente, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(133, 133, 133)
                                .addComponent(lblHora1, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblHora, javax.swing.GroupLayout.PREFERRED_SIZE, 219, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addComponent(lblPersona, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addGap(73, 73, 73))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 688, Short.MAX_VALUE)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING))
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSituacion, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblEstadoCliente, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(lblPersona, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(30, 30, 30)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblHora1, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblHora, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(lblFoto, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(34, 34, 34)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 44, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
////         Iniciar();
////	start();
////        EstadoHuellas();

        btnSalir.grabFocus();
    }//GEN-LAST:event_formWindowOpened

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        //stop();
    }//GEN-LAST:event_formWindowClosing

    private void btnSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSalirActionPerformed
        //stop();
        this.dispose();
    }//GEN-LAST:event_btnSalirActionPerformed

    private void tblContratoKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tblContratoKeyTyped

        char caracter = evt.getKeyChar();
        // Verificar si la tecla pulsada no es un digito
        if (((caracter < '0') || (caracter > '9')) && (caracter != '.' /*corresponde a BACK_SPACE*/)) {
            evt.consume();  // ignorar el evento de teclado
        }

    }//GEN-LAST:event_tblContratoKeyTyped

    private void tblEstadoKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tblEstadoKeyTyped
        // TODO add your handling code here:
    }//GEN-LAST:event_tblEstadoKeyTyped

    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new MarcacionHuella().setVisible(true);
//            }
//        });
//    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSalir;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel lblEstadoCliente;
    private javax.swing.JLabel lblFoto;
    private javax.swing.JLabel lblHora;
    private javax.swing.JLabel lblHora1;
    private javax.swing.JLabel lblPersona;
    private javax.swing.JLabel lblSituacion;
    private javax.swing.JTable tblContrato;
    private javax.swing.JTable tblEstado;
    private javax.swing.JTextArea txtArea;
    // End of variables declaration//GEN-END:variables

}
